# Note that this is NOT a relocatable package

%define glib2_base_version 2.12.0
%define glib2_version %{glib2_base_version}-1
%define pango_base_version 1.13.0
%define pango_version %{pango_base_version}-1
%define atk_base_version 1.9.0
%define atk_version %{atk_base_version}-1
%define cairo_base_version 1.2.0
%define cairo_version %{cairo_base_version}-1
%define libpng_version 2:1.2.2-16

%define base_version 2.10.4
%define bin_version 2.10.0

Summary: The GIMP ToolKit (GTK+), a library for creating GUIs for X
Name: gtk2
Version: %{base_version}
Release: 21%{?dist}.6
License: LGPL
Group: System Environment/Libraries
Source: gtk+-%{version}.tar.bz2
Source2: te.po
Source3: update-gtk-immodules
Source4: update-gdk-pixbuf-loaders

# Biarch changes
Patch0: gtk+-2.4.1-lib64.patch
# Fedora patch
Patch1: gtk+-2.8.10-set-invisible-char-to-bullet.patch
# Filechooser search
Patch2: gtk+-2.10.4-search.patch
# use fam for recent-files
Patch3: gtk+-2.10.3-fam.patch

# backport from HEAD
Patch7: gtk+-2.10.2-cursor-blink.patch

# fixed in upstream cvs
Patch8: gtk+-2.10.4-deadlock.patch
Patch9: gtk+-2.10.4-path-check.patch
Patch10: gtk+-2.10.4-strncpy.patch
Patch11: gtk+-2.10.4-panel-crash.patch
Patch12: gtk+-2.10.4-printernames.patch
Patch13: gtk+-2.10.4-icon-theme-crash.patch
Patch14: gtk+-2.10.4-message-dialog-a11y.patch
Patch15: gtk+-2.10.4-mnemonic-clipping.patch
Patch16: gtk+-2.10.4-close-loader.patch
Patch17: gtk+-2.10.4-cups-multi-value.patch

# updated indic translation from upstream cvs 2006-12-14
# also adds as and si to ALL_LINGUAS in configure.in
Patch18: gtk+-2.10.4-indic-update.patch

# Patches for GTKVTS 
Patch19: gtk+-2.10.4-treemodel-memory-corruption.patch
Patch20: gtk+-2.10.4-menu-tearofftitle.patch

# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=224202
Patch21: raw-printer.patch
# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=237153
Patch22: zero-polygon.patch
# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=218676
Patch23: calendar-langinfo.patch

# backport from upstream
Patch24: trayicon.patch

# adapted from upstream
Patch25: filechooser-fix.patch

BuildPrereq: atk-devel >= %{atk_version}
BuildPrereq: pango-devel >= %{pango_version}
BuildPrereq: glib2-devel >= %{glib2_version}
BuildPrereq: libtiff-devel
BuildPrereq: libjpeg-devel
BuildPrereq: libXi-devel
BuildPrereq: libpng-devel >= %{libpng_version}
BuildRequires: automake17 autoconf libtool pkgconfig
BuildRequires: gettext
BuildRequires: gtk-doc
BuildRequires: cups-devel
BuildRequires: cairo-devel >= %{cairo_version}
BuildRequires: libXrandr-devel
BuildRequires: libXrender-devel
BuildRequires: libXcursor-devel
BuildRequires: libXfixes-devel
BuildRequires: libXinerama-devel
# for patch 3
BuildRequires: gamin-devel

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Obsoletes: gtk+-gtkbeta
Obsoletes: Inti

# Conflicts with packages containing theme engines
# built against the 2.4.0 ABI
Conflicts: gtk2-engines < 2.7.4-7
Conflicts: libgnomeui < libgnomeui-2.15.1cvs20060505-2
Conflicts: redhat-artwork < 0.243-1

URL: http://www.gtk.org

# required for icon themes apis to work
Requires: hicolor-icon-theme

# We need to prereq these so we can run gtk-query-immodules-2.0
Prereq: glib2 >= %{glib2_version}
Prereq: atk >= %{atk_version}
Prereq: pango >= %{pango_version}
# and these for gdk-pixbuf-query-loaders
Prereq: libtiff >= 3.6.1

%define _unpackaged_files_terminate_build      1
%define _missing_doc_files_terminate_build     1


%description
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

%package devel
Summary: Development tools for GTK+ applications
Group: Development/Libraries
Requires: gtk2 = %{version}-%{release}
Requires: pango-devel >= %{pango_version}
Requires: atk-devel >= %{atk_version}
Requires: glib2-devel >= %{glib2_version}
Requires: cairo-devel >= %{cairo_version}
Requires: libX11-devel, libXcursor-devel, libXinerama-devel
Requires: libXext-devel, libXi-devel, libXrandr-devel
Requires: libXfixes-devel
Requires: pkgconfig
Obsoletes: gtk+-gtkbeta-devel
Obsoletes: Inti-devel
## avoid header collisions
Conflicts: gtk+-devel <= 1.2.8
Conflicts: gdk-pixbuf-devel <= 0.11

%description devel
The gtk+-devel package contains the header files and developer
docs for the GTK+ widget toolkit.  

%prep
%setup -q -n gtk+-%{version}

cp %{SOURCE2} po
cp %{SOURCE3} .
cp %{SOURCE4} .

%patch0 -p1 -b .lib64
%patch1 -p1 -b .set-invisible-char-to-bullet
%patch2 -p1 -b .search
%patch3 -p1 -b .fam

%patch7 -p0 -b .cursor-blink

%patch8 -p1 -b .deadlock
%patch9 -p1 -b .path-check
%patch10 -p1 -b .strncpy
%patch11 -p1 -b .panel-crash
%patch12 -p1 -b .printernames
%patch13 -p1 -b .icon-theme-crash
%patch14 -p1 -b .message-dialog-a11y
%patch15 -p1 -b .mnemonic-clipping
%patch16 -p1 -b .close-loader
%patch17 -p1 -b .cups-multi-value
%patch18 -p1 -b .indic-update
%patch19 -p0 -b .treemodel-memory-corruption
%patch20 -p1 -b .menu-tearofftitle

%patch21 -p1 -b .raw-printer
%patch22 -p1 -b .zero-polygon
%patch23 -p1 -b .calendar-langinfo
%patch24 -p1 -b .trayicon
%patch25 -p1 -b .filechooser-fix

for i in config.guess config.sub ; do
	test -f %{_datadir}/libtool/$i && cp %{_datadir}/libtool/$i .
done

%build
libtoolize --force

# Patch3 modifies gdk-pixbuf/Makefile.am
# Patch9 modifies configure.in
autoheader
aclocal-1.7
automake-1.7

if test -x /usr/bin/autoconf-2.53; then
  autoconf-2.53
elif test -x /usr/bin/autoconf-2.52; then
  autoconf-2.52
elif test -x /usr/bin/autoconf; then
  autoconf
fi

if ! pkg-config --exists pangoxft ; then
        echo "No pangoxft.pc!"
        exit 1
fi

%configure --with-xinput=xfree --disable-gtk-doc --disable-rebuilds

## smp_mflags doesn't work for now due to gdk-pixbuf.loaders, may be fixed 
## past gtk 2.1.2
make ## %{?_smp_mflags}
# turn off for now, since floatingtest needs a display
#make check

# create a dummy binary for /usr/lib/gtk-2.0/immodules to work around
# problems in our ia64 multilib infrastructure
# See https://bugzilla.redhat.com/show_bug.cgi?id=253726 for more details
echo 'int main (void) { return 0; }' > relocation-tag.c
gcc -Os relocation-tag.c -o .relocation-tag

%install
rm -rf $RPM_BUILD_ROOT

# Deriving /etc/gtk-2.0/$host location
# NOTE: Duplicated below
#
# autoconf changes linux to linux-gnu
case "%{_host}" in
  *linux) host="%{_host}-gnu"
  ;;
  *) host="%{_host}"
  ;;
esac

# autoconf uses powerpc not ppc
host=`echo $host | sed "s/^ppc/powerpc/"`

# Make sure that the host value that is passed to the compile 
# is the same as the host that we're using in the spec file
#
compile_host=`grep 'host_triplet =' gtk/Makefile | sed "s/.* = //"`

if test "x$compile_host" != "x$host" ; then
  echo 1>&2 "Host mismatch: compile='$compile_host', spec file='$host'" && exit 1
fi

make install DESTDIR=$RPM_BUILD_ROOT        \
             RUN_QUERY_IMMODULES_TEST=false \
             RUN_QUERY_LOADER_TEST=false 

%find_lang gtk20
%find_lang gtk20-properties

cat gtk20.lang gtk20-properties.lang > all.lang

./mkinstalldirs $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0
#
# Make cleaned-up versions of tutorials, examples, and faq for installation
#
./mkinstalldirs tmpdocs
cp -aR docs/tutorial/html tmpdocs/tutorial
cp -aR docs/faq/html tmpdocs/faq

for dir in examples/* ; do
    if [ -d $dir ] ; then
       ./mkinstalldirs tmpdocs/$dir
       for file in $dir/* ; do
	 install -m 0644 $file tmpdocs/$dir
       done
    fi
done

# We need to have separate 32-bit and 64-bit binaries
# for places where we have two copies of the GTK+ package installed.
# (we might have x86_64 and i686 packages on the same system, for example.)
case "$host" in
  alpha*|ia64*|powerpc64*|s390x*|x86_64*)
   mv $RPM_BUILD_ROOT%{_bindir}/gtk-query-immodules-2.0 $RPM_BUILD_ROOT%{_bindir}/gtk-query-immodules-2.0-64
   mv $RPM_BUILD_ROOT%{_bindir}/gdk-pixbuf-query-loaders $RPM_BUILD_ROOT%{_bindir}/gdk-pixbuf-query-loaders-64
   ;;
  *)
   mv $RPM_BUILD_ROOT%{_bindir}/gtk-query-immodules-2.0 $RPM_BUILD_ROOT%{_bindir}/gtk-query-immodules-2.0-32
   mv $RPM_BUILD_ROOT%{_bindir}/gdk-pixbuf-query-loaders $RPM_BUILD_ROOT%{_bindir}/gdk-pixbuf-query-loaders-32
   ;;
esac

#
# Install wrappers for the binaries
#
cp update-gtk-immodules $RPM_BUILD_ROOT%{_bindir}/update-gtk-immodules
cp update-gdk-pixbuf-loaders $RPM_BUILD_ROOT%{_bindir}/update-gdk-pixbuf-loaders

# Remove unpackaged files
rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/%{bin_version}/*/*.la

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/$host
touch $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/$host/gtk.immodules
touch $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/$host/gdk-pixbuf.loaders

# For 3rd party input modules
mkdir -p $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/immodules

# we need to install a binary in the immodules directory to make sure
# that it gets properly relocated to /emul for ia64 emulation of x86
# See https://bugzilla.redhat.com/show_bug.cgi?id=253726
install -m 0755 .relocation-tag $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/immodules

#
# We need the substitution of $host so we use an external
# file list
#
echo %dir %{_sysconfdir}/gtk-2.0/$host >> all.lang
echo %ghost %{_sysconfdir}/gtk-2.0/$host/gtk.immodules >> all.lang
echo %ghost %{_sysconfdir}/gtk-2.0/$host/gdk-pixbuf.loaders >> all.lang

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
sh /usr/bin/update-gdk-pixbuf-loaders %{_host}
sh /usr/bin/update-gtk-immodules %{_host}

%postun
/sbin/ldconfig

%files -f all.lang
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/gtk-demo
%{_bindir}/gdk-pixbuf-query-loaders*
%{_bindir}/gtk-query-immodules-2.0*
%{_bindir}/update-gdk-pixbuf-loaders
%{_bindir}/update-gtk-immodules
%{_bindir}/gtk-update-icon-cache
%{_libdir}/libgtk-x11-2.0.so.*
%{_libdir}/libgdk-x11-2.0.so.*
%{_libdir}/libgdk_pixbuf-2.0.so.*
%{_libdir}/libgdk_pixbuf_xlib-2.0.so.*
%dir %{_libdir}/gtk-2.0
%dir %{_libdir}/gtk-2.0/immodules
%{_libdir}/gtk-2.0/immodules/.relocation-tag
%{_libdir}/gtk-2.0/%{bin_version}
%{_datadir}/gtk-2.0
%{_datadir}/themes/Default
%{_datadir}/themes/Emacs
%{_datadir}/themes/Raleigh
%dir %{_sysconfdir}/gtk-2.0

%files devel
%defattr(-, root, root)

%{_libdir}/lib*.so
%dir %{_libdir}/gtk-2.0
%{_libdir}/gtk-2.0/include
%{_datadir}/gtk-doc/
%{_mandir}/man1/*
%{_includedir}/*
%{_datadir}/aclocal/*
%{_bindir}/gdk-pixbuf-csource
%{_libdir}/pkgconfig/*
%doc tmpdocs/tutorial
%doc tmpdocs/faq
%doc tmpdocs/examples

%changelog
* Tue Jun 28 2011 Snir Ifrah <sniri@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Wed Nov 24 2010 Matthias Clasen <mclasen@redhat.com> - 2.10.4-21.%{?dist}.6
- Improve the filechooser selection behavior

* Tue Nov 16 2010 Matthias Clasen <mclasen@redhat.com> - 2.10.4-21.%{?dist}.5
- Fix %%post script in ia64 multilib

* Tue Nov  9 2010 Matthias Clasen <mclasen@redhat.com> - 2.10.4-21.%{?dist}.4
- Rebuild without new sources
